#ifndef EFL_VPATH_EO_HH
#define EFL_VPATH_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_vpath.eo.h"
#include "efl_vpath_file.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#include "efl_vpath_file.eo.hh"
namespace efl { 
struct Vpath;
} 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::Vpath> : ::std::true_type {}; } }

namespace eo_cxx {
namespace efl { 
struct Vpath {
   ::efl::eolian::return_traits< ::efl::vpath::File>::type fetch( ::efl::eolian::in_traits< ::efl::eina::string_view>::type path) const;
   static Eo_Class const* _eo_class()
   {
      return EFL_VPATH_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::efl::Vpath() const;
   operator ::efl::Vpath&();
   operator ::efl::Vpath const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Vpath> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Vpath const > operator&() const { return {this}; }
   /// @endcond
};
} 
}
namespace efl { 
struct Vpath : ::efl::eo::concrete
{
   explicit Vpath( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Vpath(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Vpath(Vpath const& other) = default;
   Vpath(Vpath&& other) = default;
   Vpath& operator=(Vpath const& other) = default;
   Vpath& operator=(Vpath&& other) = default;
   Vpath()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Vpath( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Vpath(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   ::efl::eolian::return_traits< ::efl::vpath::File>::type fetch( ::efl::eolian::in_traits< ::efl::eina::string_view>::type path) const;
   static Eo_Class const* _eo_class()
   {
      return EFL_VPATH_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Vpath> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Vpath const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Vpath) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Vpath>::value, "");
} 
#include "efl_vpath.eo.impl.hh"
#endif
